pcucontrol@master
[build.git] / lbuild-initvm.sh
1 #!/bin/bash
2 # -*-shell-*-
3
4 # close stdin, as with ubuntu and debian VMs this script tends to hang and wait for input ..
5 0<&-
6
7 #shopt -s huponexit
8
9 COMMAND=$(basename $0)
10 DIRNAME=$(dirname $0)
11 BUILD_DIR=$(pwd)
12
13 # pkgs parsing utilities + lbuild-bridge.sh
14 export PATH=$(dirname $0):$PATH
15
16 # old guests have e.g. mount in /bin but this is no longer part of
17 # the standard PATH in recent hosts after usrmove, so let's keep it simple
18 export PATH=$PATH:/bin:/sbin
19
20 . build.common
21
22 # xxx fixme : we pass $lxc around in functions,
23 # but in fact then we use lxc_root which is a global..
24 # it works, but this really is poor practice
25 # we should have an lxc_root function instead
26 function lxcroot () {
27     local lxc=$1; shift
28     echo /vservers/$lxc
29 }
30
31 # XXX fixme : when creating a 32bits VM we need to call linux32 as appropriate...s
32
33 DEFAULT_FCDISTRO=f31
34 DEFAULT_PLDISTRO=lxc
35 DEFAULT_PERSONALITY=linux64
36 DEFAULT_MEMORY=3072
37
38 ##########
39 # constant
40 PUBLIC_BRIDGE=br0
41
42 # the network interface name as seen from the container
43 VIF_GUEST=eth0
44
45 ##########
46 FEDORA_MIRROR="http://mirror.onelab.eu/"
47 FEDORA_MIRROR_KEYS="http://mirror.onelab.eu/keys/"
48 FEDORA_PREINSTALLED="dnf dnf-yum passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
49 DEBIAN_PREINSTALLED="openssh-server openssh-client"
50
51 ########## networking utilities
52 function gethostbyname () {
53     local hostname=$1
54     python3 -c "import socket; print(socket.gethostbyname('"$hostname"'))" 2> /dev/null
55 }
56
57 # e.g. 21 -> 255.255.248.0
58 function masklen_to_netmask () {
59     local masklen=$1; shift
60     python3 <<EOF
61 import sys
62 masklen = $masklen
63 if not (1 <= masklen <= 32):
64   print("Wrong masklen", masklen)
65   exit(1)
66 result = []
67 for i in range(4):
68     if masklen >= 8:
69        result.append(8)
70        masklen -= 8
71     else:
72        result.append(masklen)
73        masklen = 0
74 print(".".join([ str(256-2**(8-i)) for i in result ]))
75 EOF
76 }
77
78 ##############################
79 # return dnf or debootstrap
80 function package_method () {
81     local fcdistro=$1; shift
82     case $fcdistro in
83         f[0-9]*|centos[0-9]*|sl[0-9]*)
84             echo dnf ;;
85         wheezy|jessie|trusty|xenial|bionic)
86             echo debootstrap ;;
87         *)
88             echo Unknown distro $fcdistro ;;
89     esac
90 }
91
92 # return arch from debian distro and personality
93 function canonical_arch () {
94     local personality=$1; shift
95     local fcdistro=$1; shift
96     case $(package_method $fcdistro) in
97         dnf)
98             case $personality in
99                 *32) echo i386 ;;
100                 *64) echo x86_64 ;;
101                 *) echo Unknown-arch-1 ;;
102             esac ;;
103         debootstrap)
104             case $personality in
105                 *32) echo i386 ;;
106                 *64) echo amd64 ;;
107                 *) echo Unknown-arch-2 ;;
108             esac ;;
109         *)
110             echo Unknown-arch-3 ;;
111     esac
112 }
113
114 # the new test framework creates /timestamp in /vservers/<name> *before* populating it
115 function almost_empty () {
116     local dir="$1"; shift ;
117     # non existing is fine
118     [ ! -d $dir ] && return 0;
119     # need to have at most one file
120     local count=$(cd $dir; ls | wc -l)
121     [ $count -le 1 ]
122 }
123
124 ##############################
125 function fedora_install() {
126     set -x
127     set -e
128
129     local lxc=$1; shift
130     local lxc_root=$(lxcroot $lxc)
131
132     local cache=/var/cache/lxc/fedora/$arch/${fedora_release}
133     mkdir -p $cache
134
135     (
136         flock --exclusive --timeout 60 200 || { echo "Cache repository is busy." ; return 1 ; }
137
138         if [ ! -e "$cache/rootfs" ]; then
139             echo "Getting cache download in $cache/rootfs ... "
140             fedora_download $cache || { echo "Failed to download 'fedora base'"; return 1; }
141         else
142             echo "Updating cache $cache/rootfs ..."
143             if ! dnf --installroot $cache/rootfs --releasever=${fedora_release} -y --nogpgcheck update ; then
144                 echo "Failed to update 'fedora base', continuing with last known good cache"
145             else
146                 echo "Update finished"
147             fi
148         fi
149
150         echo "Filling $lxc_root from $cache/rootfs ... "
151         rsync -a $cache/rootfs/ $lxc_root/
152
153         return 0
154
155         ) 200> $cache/lock
156
157     return $?
158 }
159
160 function fedora_download() {
161     set -x
162
163     local cache=$1; shift
164
165     # check the mini fedora was not already downloaded
166     INSTALL_ROOT=$cache/partial
167     echo $INSTALL_ROOT
168
169     # download a mini fedora into a cache
170     echo "Downloading fedora minimal ..."
171
172     mkdir -p $INSTALL_ROOT || { echo "Failed to create '$INSTALL_ROOT' directory" ; return 1; }
173
174     mkdir -p $INSTALL_ROOT/etc/yum.repos.d
175     mkdir -p $INSTALL_ROOT/dev
176     mknod -m 0444 $INSTALL_ROOT/dev/random c 1 8
177     mknod -m 0444 $INSTALL_ROOT/dev/urandom c 1 9
178
179     # copy yum config and repo files
180     cp /etc/yum.conf $INSTALL_ROOT/etc/
181     cp /etc/yum.repos.d/fedora{,-updates}.repo $INSTALL_ROOT/etc/yum.repos.d/
182
183     # append fedora repo files with hardwired releasever and basearch
184     for f in $INSTALL_ROOT/etc/yum.repos.d/* ; do
185       sed -i "s/\$basearch/$arch/g; s/\$releasever/${fedora_release}/g;" $f
186     done
187
188 # looks like all this business about fetching fedora-release is not needed
189 # it does
190 #    MIRROR_URL=$FEDORA_MIRROR/fedora/releases/${fedora_release}/Everything/$arch/os
191 #    # since fedora18 the rpms are scattered by first name
192 #    # first try the second version of fedora-release first
193 #    RELEASE_URLS=""
194 #    local subindex
195 #    for subindex in 3 2 1; do
196 #        RELEASE_URLS="$RELEASE_URLS $MIRROR_URL/Packages/f/fedora-release-${fedora_release}-${subindex}.noarch.rpm"
197 #    done
198 #
199 #    RELEASE_TARGET=$INSTALL_ROOT/fedora-release-${fedora_release}.noarch.rpm
200 #    local found=""
201 #    local attempt
202 #    for attempt in $RELEASE_URLS; do
203 #        if curl --silent --fail $attempt -o $RELEASE_TARGET; then
204 #            echo "Successfully Retrieved $attempt"
205 #            found=true
206 #            break
207 #        else
208 #            echo "Failed (not to worry about) with attempt $attempt"
209 #        fi
210 #    done
211 #    [ -n "$found" ] || { echo "Could not retrieve fedora-release rpm - exiting" ; exit 1; }
212
213     mkdir -p $INSTALL_ROOT/var/lib/rpm
214     rpm --root $INSTALL_ROOT  --initdb
215     # when installing f12 this apparently is already present, so ignore result
216 #    rpm --root $INSTALL_ROOT -ivh $INSTALL_ROOT/fedora-release-${fedora_release}.noarch.rpm || :
217     # however f12 root images won't get created on a f18 host
218     # (the issue here is the same as the one we ran into when dealing with a vs-box)
219     # in a nutshell, in f12 the glibc-common and filesystem rpms have an apparent conflict
220     # >>> file /usr/lib/locale from install of glibc-common-2.11.2-3.x86_64 conflicts
221     #          with file from package filesystem-2.4.30-2.fc12.x86_64
222     # in fact this was - of course - allowed by f12's rpm but later on a fix was made
223     #   http://rpm.org/gitweb?p=rpm.git;a=commitdiff;h=cf1095648194104a81a58abead05974a5bfa3b9a
224     # So ideally if we want to be able to build f12 images from f18 we need an rpm that has
225     # this patch undone, like we have in place on our f14 boxes (our f14 boxes need a f18-like rpm)
226
227     DNF="dnf --installroot=$INSTALL_ROOT --nogpgcheck -y"
228     echo "$DNF install $FEDORA_PREINSTALLED"
229     $DNF install $FEDORA_PREINSTALLED || { echo "Failed to download rootfs, aborting." ; return 1; }
230
231     mv "$INSTALL_ROOT" "$cache/rootfs"
232     echo "Download complete."
233
234     return 0
235 }
236
237 ##############################
238 function fedora_configure() {
239
240     set -x
241     set -e
242
243     local lxc=$1; shift
244     local fcdistro=$1; shift
245     local lxc_root=$(lxcroot $lxc)
246
247     # disable selinux in fedora
248     mkdir -p $lxc_root/selinux
249     echo 0 > $lxc_root/selinux/enforce
250
251     # enable networking and set hostname
252     cat <<EOF > ${lxc_root}/etc/sysconfig/network
253 NETWORKING=yes
254 EOF
255     cat <<EOF > ${lxc_root}/etc/hostname
256 $GUEST_HOSTNAME
257 EOF
258
259     local dev_path="${lxc_root}/dev"
260     rm -rf $dev_path
261     mkdir -p $dev_path
262     mknod -m 666 ${dev_path}/null c 1 3
263     mknod -m 666 ${dev_path}/zero c 1 5
264     mknod -m 666 ${dev_path}/random c 1 8
265     mknod -m 666 ${dev_path}/urandom c 1 9
266     mkdir -m 755 ${dev_path}/pts
267     mkdir -m 1777 ${dev_path}/shm
268     mknod -m 666 ${dev_path}/tty c 5 0
269     mknod -m 666 ${dev_path}/tty0 c 4 0
270     mknod -m 666 ${dev_path}/tty1 c 4 1
271     mknod -m 666 ${dev_path}/tty2 c 4 2
272     mknod -m 666 ${dev_path}/tty3 c 4 3
273     mknod -m 666 ${dev_path}/tty4 c 4 4
274     mknod -m 600 ${dev_path}/console c 5 1
275     mknod -m 666 ${dev_path}/full c 1 7
276     mknod -m 600 ${dev_path}/initctl p
277     mknod -m 666 ${dev_path}/ptmx c 5 2
278
279     fedora_configure_systemd $lxc
280
281     local guest_ifcfg=${lxc_root}/etc/sysconfig/network-scripts/ifcfg-$VIF_GUEST
282     mkdir -p $(dirname ${guest_ifcfg})
283     # starting with f27, we go for NetworkManager
284     # no more NM_CONTROLLED nonsense
285     if [ -n "$NAT_MODE" ]; then
286         write_guest_ifcfg_natip
287     else
288         write_guest_ifcfg_publicip
289     fi > $guest_ifcfg
290
291     [ -z "$IMAGE" ] && fedora_configure_yum $lxc $fcdistro $pldistro
292
293     return 0
294 }
295
296 # this code of course is for guests that do run on systemd
297 function fedora_configure_systemd() {
298     set -e
299     set -x
300     local lxc=$1; shift
301     local lxc_root=$(lxcroot $lxc)
302
303     # so ignore if we can't find /etc/systemd at all
304     [ -d ${lxc_root}/etc/systemd ] || return 0
305     # otherwise let's proceed
306     ln -sf /lib/systemd/system/multi-user.target ${lxc_root}/etc/systemd/system/default.target
307     touch ${lxc_root}/etc/fstab
308     ln -sf /dev/null ${lxc_root}/etc/systemd/system/udev.service
309 # Thierry - Feb 2013 relying on getty is looking for trouble
310 # so, turning getty off for now instead
311 #    sed -i 's/After=dev-%i.device/After=/' ${lxc_root}/lib/systemd/system/getty\@.service
312     ln -sf /dev/null ${lxc_root}/etc/systemd/system/"getty@.service"
313     rm -f ${lxc_root}/etc/systemd/system/getty.target.wants/*service || :
314 # can't seem to handle this one with systemctl
315 # second part should trigger starting with fedora31, where the network target is not manually manageable
316     chroot ${lxc_root} $personality chkconfig network on ||     chroot ${lxc_root} $personality systemctl enable NetworkManager
317 }
318
319 # overwrite container yum config
320 function fedora_configure_yum () {
321     set -x
322     set -e
323     trap failure ERR INT
324
325     local lxc=$1; shift
326     local fcdistro=$1; shift
327     local pldistro=$1; shift
328
329     local lxc_root=$(lxcroot $lxc)
330     # rpm --rebuilddb
331     chroot ${lxc_root} $personality rpm --rebuilddb
332
333     echo "Initializing yum.repos.d in $lxc"
334     rm -f $lxc_root/etc/yum.repos.d/*
335
336     # use mirroring/ stuff instead of a hard-wired config
337     local repofile=$lxc_root/etc/yum.repos.d/building.repo
338     yumconf_mirrors $repofile ${DIRNAME} $fcdistro \
339         "" $FEDORA_MIRROR
340     # the keys stuff requires adjustment though
341     sed -i $repofile -e s,'gpgkey=.*',"gpgkey=${FEDORA_MIRROR_KEYS}/RPM-GPG-KEY-fedora-${fedora_release}-primary,"
342
343     # import fedora key so that gpgckeck does not whine or require stdin
344     # required since fedora24
345     rpm --root $lxc_root --import $FEDORA_MIRROR_KEYS/RPM-GPG-KEY-fedora-${fedora_release}-primary
346
347     # for using this script as a general-purpose lxc creation wrapper
348     # just mention 'none' as the repo url
349     if [ -n "$REPO_URL" ] ; then
350         if [ ! -d $lxc_root/etc/yum.repos.d ] ; then
351             echo "WARNING : cannot create myplc repo"
352         else
353             # exclude kernel from fedora repos
354             yumexclude=$(pl_plcyumexclude $fcdistro $pldistro $DIRNAME)
355             for repo in $lxc_root/etc/yum.repos.d/* ; do
356                 [ -f $repo ] && yumconf_exclude $repo "exclude=$yumexclude"
357             done
358             # the build repo is not signed at this stage
359             cat > $lxc_root/etc/yum.repos.d/myplc.repo <<EOF
360 [myplc]
361 name= MyPLC
362 baseurl=$REPO_URL
363 enabled=1
364 gpgcheck=0
365 EOF
366         fi
367     fi
368 }
369
370 ##############################
371 # apparently ubuntu exposes a mirrors list by country at
372 # http://mirrors.ubuntu.com/mirrors.txt
373 # need to specify the right mirror for debian variants like ubuntu and the like
374 function debian_mirror () {
375     local fcdistro=$1; shift
376     case $fcdistro in
377         wheezy|jessie)
378             echo http://ftp2.fr.debian.org/debian/ ;;
379         trusty|xenial|bionic)
380             echo http://www-ftp.lip6.fr/pub/linux/distributions/Ubuntu/archive/ ;;
381         *) echo unknown distro $fcdistro; exit 1;;
382     esac
383 }
384
385 function debian_install () {
386     set -e
387     set -x
388     local lxc=$1; shift
389     local lxc_root=$(lxcroot $lxc)
390     mkdir -p $lxc_root
391     local arch=$(canonical_arch $personality $fcdistro)
392     local mirror=$(debian_mirror $fcdistro)
393     debootstrap --no-check-gpg --arch $arch $fcdistro $lxc_root $mirror
394     # just like with fedora we ensure a few packages get installed as well
395     # not started yet
396     #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get update"
397     #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get -y install $DEBIAN_PREINSTALLED"
398     chroot ${lxc_root} $personality apt-get update
399     chroot ${lxc_root} $personality apt-get -y install $DEBIAN_PREINSTALLED
400     # configure hostname
401     cat <<EOF > ${lxc_root}/etc/hostname
402 $GUEST_HOSTNAME
403 EOF
404
405 }
406
407 function debian_configure () {
408     local guest_interfaces=${lxc_root}/etc/network/interfaces
409     ( [ -n "$NAT_MODE" ] && write_guest_interfaces_natip || write_guest_interfaces_publicip ) > $guest_interfaces
410 }
411
412 function write_guest_interfaces_natip () {
413     cat <<EOF
414 auto $VIF_GUEST
415 iface $VIF_GUEST inet dhcp
416 EOF
417 }
418
419 function write_guest_interfaces_publicip () {
420     cat <<EOF
421 auto $VIF_GUEST
422 iface $VIF_GUEST inet static
423 address $GUEST_IP
424 netmask $NETMASK
425 gateway $GATEWAY
426 EOF
427 }
428 ##############################
429 function setup_lxc() {
430
431     set -x
432     set -e
433     #trap failure ERR INT
434
435     local lxc=$1; shift
436     local fcdistro=$1; shift
437     local pldistro=$1; shift
438     local personality=$1; shift
439
440     local lxc_root=$(lxcroot $lxc)
441
442     # create lxc container
443
444     pkg_method=$(package_method $fcdistro)
445     case $pkg_method in
446         dnf)
447             if [ -z "$IMAGE" ]; then
448                 fedora_install $lxc ||  { echo "failed to install fedora root image"; exit 1 ; }
449                 # this appears to be safer; observed in Jan. 2016 on a f23 host and a f14 cached image
450                 # we were getting this message when attempting the first chroot dnf install
451                 # rpmdb: Program version 4.8 doesn't match environment version 5.3
452                 chroot $(lxcroot $lxc) $personality rm -rf /var/lib/rpm/__db.00{0,1,2,3,4,5,6,7,8,9}
453                 chroot $(lxcroot $lxc) $personality rpm --rebuilddb
454             fi
455             fedora_configure $lxc $fcdistro || { echo "failed to configure fedora for a container"; exit 1 ; }
456             ;;
457         debootstrap)
458             if [ -z "$IMAGE" ]; then
459                 debian_install $lxc || { echo "failed to install debian/ubuntu root image"; exit 1 ; }
460             fi
461             debian_configure || { echo "failed to configure debian/ubuntu for a container"; exit 1 ; }
462             ;;
463         *)
464             echo "$COMMAND:: unknown package_method - exiting"
465             exit 1
466             ;;
467     esac
468
469     # Enable cgroup -- xxx -- is this really useful ?
470     [ -d $lxc_root/cgroup ] || mkdir $lxc_root/cgroup
471
472     ### set up resolv.conf from host
473     # ubuntu precise and on, /etc/resolv.conf is a symlink to ../run/resolvconf/resolv.conf
474     [ -h $lxc_root/etc/resolv.conf ] && rm -f $lxc_root/etc/resolv.conf
475     cp /etc/resolv.conf $lxc_root/etc/resolv.conf
476     ### and /etc/hosts for at least localhost
477     [ -f $lxc_root/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $lxc_root/etc/hosts
478
479     # grant ssh access from host to guest
480     mkdir -p $lxc_root/root/.ssh
481     cat /root/.ssh/id_rsa.pub >> $lxc_root/root/.ssh/authorized_keys
482     chmod 700 $lxc_root/root/.ssh
483     chmod 600 $lxc_root/root/.ssh/authorized_keys
484
485     # don't keep the input xml, this can be retrieved at all times with virsh dumpxml
486     local config_xml=/tmp/$lxc.xml
487     ( [ -n "$NAT_MODE" ] && write_lxc_xml_natip $lxc || write_lxc_xml_publicip $lxc ) > $config_xml
488
489     # define lxc container for libvirt
490     virsh -c lxc:/// define $config_xml
491
492     return 0
493 }
494
495 # this part does not belong in a domain any more
496 # but goes in a network object of its own existence
497 #      <network>
498 #        <name>host-bridge</name>
499 #        <forward mode="bridge"/>
500 #        <bridge name="br0"/>
501 #      </network>
502 #
503
504 function write_lxc_xml_publicip () {
505     local lxc=$1; shift
506     local lxc_root=$(lxcroot $lxc)
507     cat <<EOF
508 <domain type='lxc'>
509   <name>$lxc</name>
510   <memory>$MEMORY</memory>
511   <os>
512     <type arch='$arch2'>exe</type>
513     <init>/sbin/init</init>
514   </os>
515   <features>
516     <acpi/>
517   </features>
518   <vcpu>1</vcpu>
519   <clock offset='utc'/>
520   <on_poweroff>destroy</on_poweroff>
521   <on_reboot>restart</on_reboot>
522   <on_crash>destroy</on_crash>
523   <devices>
524     <emulator>/usr/libexec/libvirt_lxc</emulator>
525     <filesystem type='mount'>
526       <source dir='$lxc_root'/>
527       <target dir='/'/>
528     </filesystem>
529     <interface type="bridge">
530       <source bridge="$PUBLIC_BRIDGE"/>
531       <target dev='$VIF_HOST'/>
532     </interface>
533     <console type='pty' />
534   </devices>
535 </domain>
536 EOF
537 }
538
539 # grant build guests the ability to do mknods
540 function write_lxc_xml_natip () {
541     local lxc=$1; shift
542     local lxc_root=$(lxcroot $lxc)
543     cat <<EOF
544 <domain type='lxc'>
545   <name>$lxc</name>
546   <memory>$MEMORY</memory>
547   <os>
548     <type arch='$arch2'>exe</type>
549     <init>/sbin/init</init>
550   </os>
551   <features>
552     <acpi/>
553     <capabilities policy='default'>
554       <mknod state='on'/>
555     </capabilities>
556   </features>
557   <vcpu>1</vcpu>
558   <clock offset='utc'/>
559   <on_poweroff>destroy</on_poweroff>
560   <on_reboot>restart</on_reboot>
561   <on_crash>destroy</on_crash>
562   <devices>
563     <emulator>/usr/libexec/libvirt_lxc</emulator>
564     <filesystem type='mount'>
565       <source dir='$lxc_root'/>
566       <target dir='/'/>
567     </filesystem>
568     <interface type="network">
569       <source network="default"/>
570     </interface>
571     <console type='pty' />
572   </devices>
573 </domain>
574 EOF
575 }
576
577 # this one is dhcp-based
578 function write_guest_ifcfg_natip () {
579     cat <<EOF
580 DEVICE=$VIF_GUEST
581 BOOTPROTO=dhcp
582 ONBOOT=yes
583 TYPE=Ethernet
584 MTU=1500
585 EOF
586 }
587
588 # use fixed GUEST_IP as specified by GUEST_HOSTNAME
589 function write_guest_ifcfg_publicip () {
590     cat <<EOF
591 DEVICE=$VIF_GUEST
592 BOOTPROTO=static
593 ONBOOT=yes
594 HOSTNAME=$GUEST_HOSTNAME
595 IPADDR=$GUEST_IP
596 NETMASK=$NETMASK
597 GATEWAY=$GATEWAY
598 TYPE=Ethernet
599 MTU=1500
600 EOF
601 }
602
603 function devel_or_test_tools () {
604
605     set -x
606     set -e
607     trap failure ERR INT
608
609     local lxc=$1; shift
610     local fcdistro=$1; shift
611     local pldistro=$1; shift
612     local personality=$1; shift
613
614     local lxc_root=$(lxcroot $lxc)
615
616     local pkg_method=$(package_method $fcdistro)
617
618     local pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $PREINSTALLED)
619
620     ### install individual packages, then groups
621     # get target arch - use uname -i here (we want either x86_64 or i386)
622
623     local lxc_arch=$(chroot ${lxc_root} $personality uname -i)
624     # on debian systems we get arch through the 'arch' command
625     [ "$lxc_arch" = "unknown" ] && lxc_arch=$(chroot ${lxc_root} $personality arch)
626
627     local packages=$(pl_getPackages -a $lxc_arch $fcdistro $pldistro $pkgsfile)
628     local groups=$(pl_getGroups -a $lxc_arch $fcdistro $pldistro $pkgsfile)
629
630     case "$pkg_method" in
631         dnf)
632             # --allowerasing required starting with fedora24
633             #
634             local has_dnf=""
635             chroot ${lxc_root} $personality dnf --version && has_dnf=true
636             if [ -n "$has_dnf" ]; then
637                 echo "container has dnf - invoking with --allowerasing"
638                 local pkg_installer="dnf -y install --allowerasing"
639                 local grp_installer="dnf -y groupinstall --allowerasing"
640             else
641                 echo "container has only dnf"
642                 local pkg_installer="dnf -y install"
643                 local grp_installer="dnf -y groupinstall"
644             fi
645             [ -n "$packages" ] && chroot ${lxc_root} $personality $pkg_installer $packages
646             for group_plus in $groups; do
647                 local group=$(echo $group_plus | sed -e "s,+++, ,g")
648                 chroot ${lxc_root} $personality $grp_installer "$group"
649             done
650             # store current rpm list in /init-lxc.rpms in case we need to check the contents
651             chroot ${lxc_root} $personality rpm -aq > $lxc_root/init-lxc.rpms
652             ;;
653         debootstrap)
654             # for ubuntu
655             if grep -iq ubuntu /vservers/$lxc/etc/lsb-release 2> /dev/null; then
656                 # on ubuntu, at this point we end up with a single feed in /etc/apt/sources.list
657                 # we need at least to add the 'universe' feed for python-rpm
658                 ( cd /vservers/$lxc/etc/apt ; head -1 sources.list | sed -e s,main,universe, > sources.list.d/universe.list )
659                 # also adding a link to updates sounds about right
660                 ( cd /vservers/$lxc/etc/apt ; head -1 sources.list | sed -e 's, main,-updates main,' > sources.list.d/updates.list )
661                 # tell apt about the changes
662                 chroot /vservers/$lxc apt-get update
663             fi
664             for package in $packages ; do
665                 # container not started yet
666                 #virsh -c lxc:/// lxc-enter-namespace $lxc /usr/bin/$personality /bin/bash -c "apt-get install -y $package" || :
667                 chroot ${lxc_root} $personality apt-get install -y $package || :
668             done
669             ### xxx todo install groups with apt..
670             ;;
671         *)
672             echo "unknown pkg_method $pkg_method"
673             ;;
674     esac
675
676     return 0
677 }
678
679 function post_install () {
680     local lxc=$1; shift
681     local personality=$1; shift
682     local lxc_root=$(lxcroot $lxc)
683     # setup localtime from the host
684     cp /etc/localtime $lxc_root/etc/localtime
685     sshd_disable_password_auth $lxc
686     # post install hook
687     [ -n "$NAT_MODE" ] && post_install_natip $lxc $personality || post_install_myplc $lxc $personality
688     # start the VM unless specified otherwise
689     if [ -n "$START_VM" ] ; then
690         echo Starting guest $lxc
691         virsh -c lxc:/// start $lxc
692         if [ -n "$NAT_MODE" ] ; then
693             wait_for_ssh $lxc
694         else
695             wait_for_ssh $lxc $GUEST_IP
696         fi
697     fi
698 }
699
700 # just in case, let's stay on the safe side
701 function sshd_disable_password_auth () {
702     local lxc=$1; shift
703     local lxc_root=$(lxcroot $lxc)
704     sed --in-place=.password -e 's,^#\?PasswordAuthentication.*,PasswordAuthentication no,' \
705         $lxc_root/etc/ssh/sshd_config
706 }
707
708 function post_install_natip () {
709
710     set -x
711     set -e
712     trap failure ERR INT
713
714     local lxc=$1; shift
715     local personality=$1; shift
716     local lxc_root=$(lxcroot $lxc)
717
718 ### From myplc-devel-native.spec
719 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
720     cat << EOF | chroot ${lxc_root} $personality bash -x
721
722     # customize root's prompt
723     /bin/cat << PROFILE > /root/.profile
724 export PS1="[$lxc] \\w # "
725 PROFILE
726
727 EOF
728
729 }
730
731 function post_install_myplc  () {
732     set -x
733     set -e
734     trap failure ERR INT
735
736     local lxc=$1; shift
737     local personality=$1; shift
738     local lxc_root=$(lxcroot $lxc)
739
740 # be careful to backslash $ in this, otherwise it's the root context that's going to do the evaluation
741     cat << EOF | chroot ${lxc_root} $personality bash -x
742
743     # create /etc/sysconfig/network if missing
744     [ -f /etc/sysconfig/network ] || /bin/echo NETWORKING=yes > /etc/sysconfig/network
745
746     # turn off regular crond, as plc invokes plc_crond
747     /sbin/chkconfig crond off
748
749     # customize root's prompt
750     /bin/cat << PROFILE > /root/.profile
751 export PS1="[$lxc] \\w # "
752 PROFILE
753
754 EOF
755 }
756
757 ########################################
758 # workaround for broken lxc-enter-namespace
759 # 1st version was relying on virsh net-dhcp-leases
760 # however this was too fragile, would not work for fedora14 containers
761 # WARNING: this code is duplicated in lbuild-nightly.sh
762 function guest_ipv4() {
763     local lxc=$1; shift
764
765     local mac=$(virsh -c lxc:/// domiflist $lxc | egrep 'network|bridge' | awk '{print $5;}')
766     # sanity check
767     [ -z "$mac" ] && return 0
768     arp -en | grep "$mac" | awk '{print $1;}'
769 }
770
771 function wait_for_ssh () {
772     set -x
773     set -e
774
775     local lxc=$1; shift
776
777     # if run in public_ip mode, we know the IP of the guest and it is specified here
778     [ -n "$1" ] && { guest_ip=$1; shift; }
779
780     #wait max 2 min for sshd to start
781     local success=""
782     local current_time=$(date +%s)
783     local stop_time=$(($current_time + 120))
784
785     local counter=1
786     while [ "$current_time" -lt "$stop_time" ] ; do
787         echo "$counter-th attempt to reach sshd in container $lxc ..."
788         [ -z "$guest_ip" ] && guest_ip=$(guest_ipv4 $lxc)
789         [ -n "$guest_ip" ] && ssh -o "StrictHostKeyChecking no" $guest_ip 'uname -i' && {
790             success=true; echo "SSHD in container $lxc is UP on IP $guest_ip"; break ; } || :
791         # some of our boxes have gone through a long upgrade historically, and
792         # so they don't end up with the same gid mapping for the ssh_keys
793         # group as the ones in the guest that result from a fresh install
794         virsh -c lxc:/// lxc-enter-namespace $lxc /bin/bash -c "chown root:ssh_keys /etc/ssh/*_key" || :
795         counter=$(($counter+1))
796         sleep 10
797         current_time=$(date +%s)
798     done
799
800     # Thierry: this is fatal, let's just exit with a failure here
801     [ -z $success ] && { echo "SSHD in container $lxc could not be reached (guest_ip=$guest_ip)" ; exit 1 ; }
802     return 0
803 }
804
805 ####################
806 function failure () {
807     echo "$COMMAND : Bailing out"
808     exit 1
809 }
810
811 function usage () {
812     set +x
813     echo "Usage: $COMMAND [options] lxc-name             (aka build mode)"
814     echo "Usage: $COMMAND -n hostname [options] lxc-name (aka test mode)"
815     echo "Description:"
816     echo "    This command creates a fresh lxc instance, for building, or running a test myplc"
817     echo "In its first form, spawned VM gets a private IP bridged with virbr0 over dhcp/nat"
818     echo "With the second form, spawned VM gets a public IP bridged on public bridge br0"
819     echo ""
820     echo "Supported options"
821     echo " -n hostname - the hostname to use in container"
822     echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
823     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO - current support for fedoras debians ubuntus"
824     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
825     echo " -r repo-url - used to populate yum.repos.d - required in test mode"
826     echo " -P pkgs_file - defines a set of extra packages to install in guest"
827     echo "    by default we use devel.pkgs (build mode) or runtime.pkgs (test mode)"
828     echo " -i image - the location of the rootfs"
829     echo " -m memory - the amount of allocated memory in MB - defaults to $DEFAULT_MEMORY MB"
830     echo " -s do not start VM"
831     echo " -v be verbose"
832     exit 1
833 }
834
835 ### parse args and
836 function main () {
837
838     #set -e
839     #trap failure ERR INT
840
841     if [ "$(id -u)" != "0" ]; then
842           echo "This script should be run as 'root'"
843           exit 1
844     fi
845
846     START_VM=true
847     while getopts "n:f:d:p:r:P:i:m:sv" opt ; do
848         case $opt in
849             n) GUEST_HOSTNAME=$OPTARG;;
850             f) fcdistro=$OPTARG;;
851             d) pldistro=$OPTARG;;
852             p) personality=$OPTARG;;
853             r) REPO_URL=$OPTARG;;
854             P) PREINSTALLED=$OPTARG;;
855             i) IMAGE=$OPTARG;;
856             m) MEMORY=$OPTARG;;
857             s) START_VM= ;;
858             v) VERBOSE=true; set -x;;
859             *) usage ;;
860         esac
861     done
862
863     shift $(($OPTIND - 1))
864
865     # parse fixed arguments
866     [[ -z "$@" ]] && usage
867     local lxc=$1 ; shift
868     local lxc_root=$(lxcroot $lxc)
869
870     # rainchecks
871     # when using with the -i option, checking that $lxc_root is void
872     # is a little too much stress..
873     almost_empty $lxc_root || \
874         { echo "container $lxc already exists in $lxc_root - exiting" ; exit 1 ; }
875     virsh -c lxc:/// domuuid $lxc >& /dev/null && \
876         { echo "container $lxc already exists in libvirt - exiting" ; exit 1 ; }
877     mkdir -p $lxc_root
878
879     # if IMAGE, copy the provided rootfs to lxc_root
880     if [ -n "$IMAGE" ] ; then
881         if [ ! -d "$IMAGE" ]; then
882             echo "$IMAGE rootfs folder does not exist - exiting"
883             exit 1
884         else
885             echo "Copying $IMAGE into $lxc_root with rsync --archive --delete"
886             rsync --archive --delete $IMAGE/ $lxc_root/
887         fi
888     fi
889
890     # check we've exhausted the arguments
891     [[ -n "$@" ]] && usage
892
893     # NAT_MODE is true unless we specified a hostname
894     [ -n "$GUEST_HOSTNAME" ] || NAT_MODE=true
895
896     # set default values
897     [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
898     [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
899     [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
900     [ -z "$MEMORY" ] && MEMORY=$DEFAULT_MEMORY
901
902     # set memory in KB
903     MEMORY=$(($MEMORY * 1024))
904
905     # the set of preinstalled packages - depends on mode
906     if [ -z "$PREINSTALLED" ] ; then
907         if [ -n "$NAT_MODE" ] ; then
908             PREINSTALLED=devel.pkgs
909         else
910             PREINSTALLED=runtime.pkgs
911         fi
912     fi
913
914     if [ -n "$NAT_MODE" ] ; then
915         # we can now set GUEST_HOSTNAME safely
916         [ -z "$GUEST_HOSTNAME" ] && GUEST_HOSTNAME=$(echo $lxc | sed -e 's,\.,-,g')
917     else
918         # as this command can be used in other contexts, not specifying
919         # a repo is considered a warning
920         # use -r none to get rid of this warning
921         if [ "$REPO_URL" == "none" ] ; then
922             REPO_URL=""
923         elif [ -z "$REPO_URL" ] ; then
924             echo "WARNING -- setting up a yum repo is recommended"
925         fi
926     fi
927
928     ##########
929     fedora_release=$(echo $fcdistro | cut -df -f2)
930
931     if [ "$personality" == "linux32" ]; then
932         arch=i386
933         arch2=i686
934     elif [ "$personality" == "linux64" ]; then
935         arch=x86_64
936         arch2=x86_64
937     else
938         echo "Unknown personality: $personality"
939     fi
940
941     # compute networking details for the test mode
942     # (build mode relies entirely on dhcp on the private subnet)
943     if [ -z "$NAT_MODE" ] ; then
944
945         #create_bridge_if_needed $PUBLIC_BRIDGE
946         lbuild-bridge.sh $PUBLIC_BRIDGE
947
948         GUEST_IP=$(gethostbyname $GUEST_HOSTNAME)
949         # use same NETMASK as bridge interface br0
950         masklen=$(ip addr show $PUBLIC_BRIDGE | grep -v inet6 | grep inet | awk '{print $2;}' | cut -d/ -f2)
951         NETMASK=$(masklen_to_netmask $masklen)
952         GATEWAY=$(ip route show | grep default | awk '{print $3}' | head -1)
953         VIF_HOST="vif$(echo $GUEST_HOSTNAME | cut -d. -f1)"
954     fi
955
956     setup_lxc $lxc $fcdistro $pldistro $personality
957
958     # historically this command is for setting up a build or a test VM
959     # kind of patchy right now though
960     devel_or_test_tools $lxc $fcdistro $pldistro $personality
961
962     # container gets started here
963     post_install $lxc $personality
964
965     echo $COMMAND Done
966
967     exit 0
968 }
969
970 main "$@"